/*
 * Copyright (c) 2016 咖枯 <kaku201313@163.com | 3772304@qq.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package com.ehsure.ehsure_location_map.location.presenter.base;

import android.app.Activity;

import androidx.annotation.NonNull;

import com.ehsure.ehsure_location_map.location.base.delegate.IView;
import com.trello.navi2.NaviComponent;
import com.trello.rxlifecycle2.LifecycleProvider;
import com.trello.rxlifecycle2.android.ActivityEvent;
import com.trello.rxlifecycle2.navi.NaviLifecycle;

public class BasePresenterImpl<T extends IView> implements BasePresenter {

    protected T mView;

    @Override
    public void attachView(@NonNull IView view) {
        mView = (T) view;
    }

    protected LifecycleProvider<ActivityEvent> getLifecycleProvider(Activity activity) {
        return NaviLifecycle.createActivityLifecycleProvider((NaviComponent) activity);
    }

    @Override
    public void onDestroy() {

    }
}
