package com.ehsure.ehsure_location_map.location.utils;

import java.util.UUID;

public class CommonUtil {

    public static String getUUID(){
        return UUID.randomUUID().toString().replaceAll("-", "").toLowerCase();
    }


    /*
     *计算两个经纬度之间的距离  结果单位：米
     */
    public static double getDistance(double lat1, double lon1, double lat2, double lon2) {
        //地球半径
        double EARTH_RADIUS = 6371000;
        double radLat1 = rad(lat1);
        double radLat2 = rad(lat2);
        double a = radLat1 - radLat2;
        double b = rad(lon1) - rad(lon2);
        double s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a/2),2) +
                Math.cos(radLat1)*Math.cos(radLat2)*Math.pow(Math.sin(b/2),2)));
        s = s * EARTH_RADIUS;
        s = Math.round(s * 1000)/1000;
        return s;
    }
    private static double rad(double d) {
        return d * Math.PI / 180.0;
    }
}
